--- asterisk-1.6.0.last/apps/app_chanspy.c	(revision 179738)
+++ asterisk-1.6.0.last/apps/app_chanspy.c	(working copy)
@@ -87,6 +87,7 @@
 "                    talk to the spied-on channel but cannot listen to that\n"
 "                    channel.\n"
 "    o             - Only listen to audio coming from this channel.\n"
+"    s             - Stop when no more channels left to spy on.\n"
 "    X             - Allow the user to exit ChanSpy to a valid single digit\n"
 "                    numeric extension in the current context or the context\n"
 "                    specified by the SPY_EXIT_CONTEXT channel variable. The\n"
@@ -127,6 +128,7 @@
 "                    talk to the spied-on channel but cannot listen to that\n"
 "                    channel.\n"
 "    o             - Only listen to audio coming from this channel.\n"
+"    s             - Stop when no more extensions left to spy on.\n"
 "    X             - Allow the user to exit ChanSpy to a valid single digit\n"
 "                    numeric extension in the current context or the context\n"
 "                    specified by the SPY_EXIT_CONTEXT channel variable. The\n"
@@ -145,6 +147,7 @@
 	OPTION_READONLY  = (1 << 7),    /* Don't mix the two channels */
 	OPTION_EXIT      = (1 << 8),    /* Exit to a valid single digit extension */
 	OPTION_ENFORCED  = (1 << 9),    /* Enforced mode */
+	OPTION_STOP      = (1 << 10),   /* Stop if no more channels */
 } chanspy_opt_flags;
 
 enum {
@@ -165,6 +168,7 @@
 	AST_APP_OPTION_ARG('r', OPTION_RECORD, OPT_ARG_RECORD),
 	AST_APP_OPTION_ARG('e', OPTION_ENFORCED, OPT_ARG_ENFORCED),
 	AST_APP_OPTION('o', OPTION_READONLY),
+	AST_APP_OPTION('s', OPTION_STOP),
 	AST_APP_OPTION('X', OPTION_EXIT),
 });
 
@@ -758,6 +762,10 @@
 		}
 		if (res == -1 || ast_check_hangup(chan))
 			break;
+		if (ast_test_flag(flags, OPTION_STOP)) {
+			if (! peer_chanspy_ds)
+				break;
+		}
 	}
 exit:
